include "VVram.inc"
include "Chars.inc"

ext VVram_
ext CellMap_
ext LineRed_

MapWidth equ VVramWidth/2
MapHeight equ VVramHeight/2

Cell_Wall equ 10h
Cell_Item equ 20h
Cell_Mask equ 0f0h


; ptr<byte> VVramPtr(byte x, byte y);
cseg
VVramPtr_: public VVramPtr_
    push psw | push b
        mov c,a

        mov a,e
        add a ;*2
        add e ;*3
        mov l,a
        mvi h,0
        dad h ;*6
        dad h ;*12
        dad h ;*24
        mvi b,0
        dad b
        lxi b,VVram_
        dad b
    pop b | pop psw
ret


; void MapToVVram();
cseg
LineChars:
    defb Char_Space, Char_Space, Char_Space, Char_Space ; none
    defb Char_Line_Bottom, Char_Space, Char_Line_Top, Char_Space ; left
    defb Char_Space, Char_Line_Bottom, Char_Space, Char_Line_Top ; right
    defb Char_Line_Bottom, Char_Line_Bottom, Char_Line_Top, Char_Line_Top ; left right
    defb Char_Line_Right, Char_Line_Left, Char_Space, Char_Space ; top
    defb Char_Line_RightBottom, Char_Line_Left, Char_Line_Top, Char_Space ; top left
    defb Char_Line_Right, Char_Line_LeftBottom, Char_Space, Char_Line_Top ; top right
    defb Char_Line_RightBottom, Char_Line_LeftBottom, Char_Line_Top, Char_Line_Top ; top left right
    defb Char_Space, Char_Space, Char_Line_Right, Char_Line_Left ; bottom
    defb Char_Line_Bottom, Char_Space, Char_Line_RightTop, Char_Line_Left ; bottom left
    defb Char_Space, Char_Line_Bottom, Char_Line_Right, Char_Line_LeftTop ; bottom right
    defb Char_Line_Bottom, Char_Line_Bottom, Char_Line_RightTop, Char_Line_LeftTop ; bottom left right
    defb Char_Line_Right, Char_Line_Left, Char_Line_Right, Char_Line_Left ; bottom top
    defb Char_Line_RightBottom, Char_Line_Left, Char_Line_RightTop, Char_Line_Left ; bottom top left
    defb Char_Line_Right, Char_Line_LeftBottom, Char_Line_Right, Char_Line_LeftTop ; bottom top right
    defb Char_Line_RightBottom, Char_Line_LeftBottom, Char_Line_RightTop, Char_Line_LeftTop ; bottom top left right

MapToVVram_: public MapToVVram_
    push psw | push h | push d | push b
        lxi h,VVram_
        lxi d,CellMap_
        mvi c,MapHeight
        do
            mvi b,MapWidth
            do
                push b
                    ldax d | inx d
                    cpi Cell_Wall
                    if z
                        mvi a,Char_Block
                        jmp byChar
                    endif
                    cpi Cell_Item
                    if z
                        mvi a,Char_Item
                        byChar:
                        push b
                            mvi c,2
                            do
                                mvi b,2
                                do
                                    mov m,a | inx h
                                    inr a
                                    dcr b
                                while nz | wend
                                push d
                                    lxi d,VVramWidth-2
                                    dad d
                                pop d
                                dcr c
                            while nz | wend
                        pop b
                        jmp nextCell
                    endif
                    ani $0f
                    add a
                    add a
                    push d
                        adi low LineChars
                        mov e,a
                        mvi a,high LineChars
                        aci 0
                        mov d,a
                        push b
                            mvi c,2
                            do
                                mvi b,2
                                do
                                    ldax d | inx d
                                    push psw
                                        ora a
                                        if nz
                                            push d
                                                mov e,a
                                                lda LineRed_
                                                ora a
                                                if nz
                                                    mov a,e
                                                    adi Char_Line_Red-Char_Line_Normal
                                                    mov e,a
                                                endif
                                                mov a,e
                                            pop d
                                        endif
                                        mov m,a | inx h
                                    pop psw
                                    dcr b
                                while nz | wend
                                push d
                                    lxi d,VVramWidth-2
                                    dad d
                                pop d
                                dcr c
                            while nz | wend
                        pop b
                    pop d
                    nextCell:
                    push d
                        lxi d,2-VVramWidth*2
                        dad d
                    pop d
                pop b
                dcr b
            while nz | wend
            push d
                lxi d,VVramWidth
                dad d
            pop d
            dcr c
        while nz | wend
    pop b | pop d | pop h | pop psw
ret


; ptr<byte> CellMapPtr(byte x, byte y);
cseg
CellMapPtr_: public CellMapPtr_
    push psw | push b
        mov c,a

        mov a,e
        add a ;*2
        add e ;*3
        mov l,a
        mvi h,0
        dad h ;*6
        dad h ;*12
        mvi b,0
        dad b
        lxi b,CellMap_
        dad b
    pop b | pop psw
ret
